.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/postquel/RCS/cluster.cmdsrc,v 1.7 1993/01/26 02:43:13 aoki Exp
.TH CLUSTER COMMANDS 01/23/93
.XA 2 Cluster
.SH NAME
cluster \(em give storage clustering advice to \*(PG
.SH SYNOPSIS
.(l M
\fBcluster\fR classname \fBon\fR attname [ \fBusing\fR operator ]
.)l
.SH DESCRIPTION
This command instructs \*(PG to keep the class specified by
.IR classname
approximately sorted on
.IR attname
using the specified operator to determine the sort order.  The
operator must be a binary operator and both operands must be of type
.IR attname
and the operator must produce a result of type boolean.  If no
operator is specified, then \*(lq<\*(rq is used by default.
.PP
A class can be reclustered at any time on a different
.IR attname
and/or with a different 
.IR operator .
.PP
\*(PG will try to keep the heap data structure which stores the
instances of this class approximately in sorted order.  If the user
specifies an operator which does not define a linear ordering, this
command will produce unpredictable orderings.
.PP
Also, if there is no index for the clustering attribute, then this
command will have no effect.
.SH EXAMPLE
.(C
/*
 * cluster employees in salary order
 */
cluster emp on salary
.)C
.SH BUGS
.IR Cluster
has no effect in Version \*(PV.
