.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/postquel/RCS/destroy.cmdsrc,v 1.7 1994/03/12 10:52:19 aoki Exp
.TH DESTROY COMMANDS 02/14/94
.XA 2 Destroy
.SH NAME
destroy \(em destroy existing classes
.SH SYNOPSIS
.(l M
\fBdestroy\fR classname-1 { \fB,\fR classname-i }
.)l
.SH DESCRIPTION
.BR Destroy
removes classes from the data base.  Only its owner may destroy a
class.  A class may be emptied of instances, but not destroyed, by
using 
.IR delete (commands).
.PP
If a class being destroyed has secondary indices on it, then they will
be removed first.  The removal of just a secondary index will not
affect the indexed class.
.PP
This command may be used to destroy a version class which is not a
parent of some other version.  Destroying a class which is a parent of
a version class is disallowed.  Instead, 
.IR merge (commands)
should be used.  Moreover, destroying a class whose fields
are inherited by other classes is similarly disallowed.  An
inheritance hierarchy must be destroyed from leaf level to root level.
.PP
The destruction of classes is not reversable.  Thus, a destroyed class
will not be recovered if a transaction which destroys this class fails
to commit.  In addition, historical access to instances in a destroyed
class is not possible.
.SH EXAMPLE
.(C
/*
 * Destroy the emp class
 */
destroy emp
.)C
.(C
/*
 * Destroy the emp and parts classes
 */
destroy emp, parts
.)C
.SH "SEE ALSO"
delete(commands),
merge(commands),
remove index(commands).
