.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-4.2-devel/src/ref/postquel/RCS/remove_operator.cmdsrc,v 1.6 1994/02/01 18:36:03 aoki Exp
.TH "REMOVE OPERATOR" COMMANDS 02/01/94
.XA 2 "Remove Operator"
.SH NAME
remove operator \(em remove an operator from the system
.SH SYNOPSIS
.(l M
\fBremove operator\fR opr_desc
.)l
.SH DESCRIPTION
This command drops an existing operator from the database.  To execute
this command you must be the owner of the operator.
.PP
.IR Opr_desc
is the name of the operator to be removed followed by a parenthesized
list of the operand types for the operator.  The left or right type
of a left or right unary operator, respectively, may be specified
as
.IR none .
.PP
It is the user's responsibility to remove any access methods, operator
classes, etc. that rely on the deleted operator.
.SH EXAMPLE
.(C
/*
 * Remove power operator a^n for int4
 */
remove operator ^ (int4, int4)
.)C
.(C
/*
 * Remove left unary operator !a for booleans
 */
remove operator ! (none, bool)
.)C
.(C
/*
 * Remove right unary factorial operator a! for int4
 */
remove operator ! (int4, none)
.)C
.(C
/*
 * Remove right unary factorial operator a! for int4
 * (default is right unary)
 */
remove operator ! (int4)
.)C
.SH "SEE ALSO"
define operator(commands).
